program day9
    implicit none
    integer, parameter :: max_chars = 300
    integer, parameter :: max_seqs = 1000
    character(200) :: fname
    character(max_chars) :: fline
    integer :: n_arguments
    integer :: istat
    integer :: seq_len
    integer, allocatable :: seq(:), revseq(:)
    integer :: i, i2, lnum_sum, fnum_sum, thislseq, thisfseq

    n_arguments = command_argument_count()
    if (n_arguments .eq. 2) then
        call get_command_argument(1, fname)
        call get_command_argument(2, fline)
        read(fline, *) seq_len
        print *, "File: ", trim(fname)
        print *, "Sequence length: ", seq_len
        print *
    else
        print *, "Wrong number of arguments: ", n_arguments
        stop
    end if
    allocate(seq(1:seq_len))
    allocate(revseq(1:seq_len))
    open(10, file=fname)
    lnum_sum = 0
    fnum_sum = 0
    do i=1,max_seqs
        read(10, "(a)", iostat=istat) fline
        if ((len_trim(fline) .eq. 0) .or. (is_iostat_end(istat))) then
            exit
        end if
        read(fline, *) seq
        do i2=1,seq_len
            revseq(i2) = seq(seq_len - i2 + 1)
        end do
        thislseq = seq(seq_len) + diffseq(seq, seq_len)
        thisfseq = revseq(seq_len) + diffseq(revseq, seq_len)
        lnum_sum = lnum_sum + thislseq
        fnum_sum = fnum_sum + thisfseq
        print *, i, thislseq, lnum_sum, thisfseq, fnum_sum
    end do

    print *, "Last number sum:  ", lnum_sum
    print *, "First number sum: ", fnum_sum


    close(10)
    deallocate(seq)
    deallocate(revseq)

    contains
        recursive function diffseq(seqin, lenin) result(seqlast)
            implicit none
            integer, intent(in) :: seqin(:)
            integer, intent(in) :: lenin
            integer :: seqlast
            integer, allocatable :: l1seq(:)
            integer :: last_l2
            integer :: i
            integer :: diff
            logical :: allsame
            allsame = .true.
            diff = seqin(lenin)
            do i=1,lenin
                if (seqin(i) .ne. diff) then
                    allsame = .false.
                    exit
                end if
            end do
            if (allsame) then
                seqlast = 0
            else
                allocate(l1seq(1:(lenin-1)), source=0)
                do i=1, lenin-1
                    l1seq(i) = seqin(i+1) - seqin(i)
                end do
                last_l2 = diffseq(l1seq, lenin-1)
                seqlast = l1seq(lenin - 1) + last_l2
                deallocate(l1seq)
            end if
        end function diffseq

end program day9

